/**
 * This file was auto-generated by openapi-typescript.
 * Do not make direct changes to the file.
 */

export interface paths {
  "/account/{network}/{address}/balance": {
    get: operations["balance"];
  };
  "/account/{network}/{address}/tokens": {
    get: operations["getSPL"];
  };
  "/account/{network}/{address}/nft": {
    get: operations["getNFTs"];
  };
  "/account/{network}/{address}/portfolio": {
    get: operations["getPortfolio"];
  };
  "/nft/{network}/{address}/metadata": {
    get: operations["getNFTMetadata"];
  };
}

export interface components {
  schemas: {
    NativeBalance: {
      solana: string;
      lamports: string;
    };
    SPLTokenBalance: {
      associatedTokenAddress: string;
      mint: string;
      amount: string;
      amountRaw: string;
      decimals: number;
    };
    SPLNFT: {
      associatedTokenAddress: string;
      mint: string;
    };
    Portfolio: {
      nativeBalance: components["schemas"]["NativeBalance"];
      nfts: components["schemas"]["SPLNFT"][];
      tokens: components["schemas"]["SPLTokenBalance"][];
    };
    MetaplexNFT: {
      metadataUri: string;
      masterEdition: boolean;
      isMutable: boolean;
      primarySaleHappened: boolean;
      sellerFeeBasisPoints: number;
      updateAuthority: string;
    };
    NFTMetadata: {
      mint: string;
      standard: string;
      name: string;
      symbol: string;
      metaplex: components["schemas"]["MetaplexNFT"];
    };
  };
}

export interface operations {
  balance: {
    parameters: {
      path: {
        network: "mainnet" | "devnet";
        address: string;
      };
    };
    responses: {
      200: {
        content: {
          "application/json": components["schemas"]["NativeBalance"];
        };
      };
    };
  };
  getSPL: {
    parameters: {
      path: {
        network: "mainnet" | "devnet";
        address: string;
      };
    };
    responses: {
      200: {
        content: {
          "application/json": components["schemas"]["SPLTokenBalance"][];
        };
      };
    };
  };
  getNFTs: {
    parameters: {
      path: {
        network: "mainnet" | "devnet";
        address: string;
      };
    };
    responses: {
      200: {
        content: {
          "application/json": components["schemas"]["SPLNFT"][];
        };
      };
    };
  };
  getPortfolio: {
    parameters: {
      path: {
        address: string;
        network: "mainnet" | "devnet";
      };
    };
    responses: {
      200: {
        content: {
          "application/json": components["schemas"]["Portfolio"];
        };
      };
    };
  };
  getNFTMetadata: {
    parameters: {
      path: {
        address: string;
        network: "mainnet" | "devnet";
      };
    };
    responses: {
      200: {
        content: {
          "application/json": components["schemas"]["NFTMetadata"];
        };
      };
    };
  };
}

export interface external {}

export default class SolanaApi {
  static initialize: (options: {apiKey?: string, serverUrl?: string, Moralis?: any}) => void;

  static account: {
    balance: (options: operations["balance"]["parameters"]["path"]) => Promise<operations["balance"]["responses"]["200"]["content"]["application/json"]>;
    getSPL: (options: operations["getSPL"]["parameters"]["path"]) => Promise<operations["getSPL"]["responses"]["200"]["content"]["application/json"]>;
    getNFTs: (options: operations["getNFTs"]["parameters"]["path"]) => Promise<operations["getNFTs"]["responses"]["200"]["content"]["application/json"]>;
    getPortfolio: (options: operations["getPortfolio"]["parameters"]["path"]) => Promise<operations["getPortfolio"]["responses"]["200"]["content"]["application/json"]>;
  }

  static nft: {
    getNFTMetadata: (options: operations["getNFTMetadata"]["parameters"]["path"]) => Promise<operations["getNFTMetadata"]["responses"]["200"]["content"]["application/json"]>;
  }

}
